//////////////////////////
// JavaScript Document
// InDesign CS 2 Script
// created May 6, 2005 by Brian Reyman
// This script takes the currently selected object(s) and centers them to the page/margins as chosen by the user
//////////////////////////

if (app.documents.length > 0){
	if (app.selection.length > 0){
		myAlignToPage();
	}
	else{
		alert(".  .     ");
	}
}
else{
	alert("  .   ,  ,  ");
}

function myAlignToPage(){
	
	
	// display the dialog for choices of align left, right, top, bottom, middle and 'to guides'
		with (myDialog = app.dialogs.add({name:"  "})){
			with(dialogColumns.add()){
				with(borderPanels.add()){
					staticTexts.add({staticLabel:":"});
					with(dialogColumns.add()){
						with(myTypeAlign = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:""});
							radiobuttonControls.add({staticLabel:""});
							radiobuttonControls.add({staticLabel:""});
							radiobuttonControls.add({staticLabel:""});
							radiobuttonControls.add({staticLabel:" "});
							radiobuttonControls.add({staticLabel:" "});
						}
					}
				}
			}
			
			with(dialogColumns.add()){
				with(borderPanels.add()){
					staticTexts.add({staticLabel:" :"});
					with(dialogColumns.add()){
						with(myTypeToWhat = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"", checkedState:true});
							radiobuttonControls.add({staticLabel:""});
						}
					}
				}
			}
		} //end dialog creation
		
		
		myResult = myDialog.show();
		
		// take the info and store it to change the actual objects
		if(myResult = true){
			var alignWhere = myTypeAlign.selectedButton;
			var alignType =  myTypeToWhat.selectedButton;
		}else{
			myDialog.destroy();
		}
		
				
	// loop through each of the selected objects and perform the action
	for(myCounter = 0; myCounter < app.selection.length; myCounter ++){
		myObject = app.selection[myCounter];
		
		// retrieve current bounds for use in those that shouldn't change
		var myBounds = new Array();
		myBounds = app.selection[myCounter].visibleBounds;
		
		var myPageWidth;
		var myPageHeight;
		// the width and height tell us the right and bottom markers, we need some variables for left and top
		var myLeft;
		var myTop;

		
		// determine if set to page or margins and set x and y coordinates and page width/height appropriately
		if (alignType == 0){
			// if it is aligned to the page
			myLeft = 0;
			myTop = 0;
		
			// determine page width/height for use later
			myPageWidth = app.activeDocument.documentPreferences.pageWidth;
			myPageHeight = app.activeDocument.documentPreferences.pageHeight;
		}else if(alignType == 1){
			//if it is aligned to guides
			myLeft = app.activeWindow.activePage.marginPreferences.right;
			myTop = app.activeWindow.activePage.marginPreferences.top;
		
			// determine page width/height for use later
			myPageWidth = app.activeDocument.documentPreferences.pageWidth - (app.activeWindow.activePage.marginPreferences.left + app.activeWindow.activePage.marginPreferences.right);
			myPageHeight = app.activeDocument.documentPreferences.pageHeight - (app.activeWindow.activePage.marginPreferences.top + app.activeWindow.activePage.marginPreferences.bottom);
		}
		
		
		// can't get the "to" part of things to work, so i am having to move everything by a certain amount
		
		switch (alignWhere){
			// align left
			case 0:
				myObject.move("by", [myLeft-myBounds[1], "0"]);
				break;
			// align right
			case 1:
				myObject.move("by", [myPageWidth-myBounds[3], "0"]);
				break;
			// align top
			case 2:
				myObject.move("by", ["0", myTop-myBounds[0]]);
				break;
			// align bottom
			case 3:
				myObject.move("by", ["0", myPageHeight-myBounds[2]]);
				break;
			// align hor center
			case 4:
				myObject.move("by", [(myPageWidth/2 + myLeft) - (myBounds[1]+(myBounds[3]-myBounds[1])/2), "0"]);
				break;
			// align ver center
			case 5:
				myObject.move("by", ["0", (myPageHeight/2 + myTop) - (myBounds[0]+(myBounds[2]-myBounds[0])/2)]);
				break;			
		} //end switch
		
		
	} // end for loop
}