﻿//StorySpliter.jsx
//An InDesign CS/CS2 JavaScript by FourAces
//© The Final Touch 2006
//Version 2.2
//
//Splits the selected Story to sepsrate Text Frames, while maintaining their contents.
//
if(app.documents.length != 0){
	var mySelection = app.activeDocument.selection;
	if(mySelection.length != 0){
		myObjectType = mySelection[0].constructor.name;
		if(myObjectType == "TextFrame"){
			//The Interface Dialog
			var myDialog = app.dialogs.add({name:"אפשרויות פיצול סיפור"});
			with(myDialog){
				with(dialogColumns.add()){
					with(borderPanels.add()){
						var mySplitOptions = radiobuttonGroups.add();
						with(mySplitOptions){
							radiobuttonControls.add({staticLabel:"פצל את כל הפריימים", checkedState:true});
							radiobuttonControls.add({staticLabel:"פצל לפני הפריים הנבחר"});
							radiobuttonControls.add({staticLabel:"פצל לאחר הפריים הנבחר"});
						}
					}
				}
			}
			var myResult = myDialog.show({name:"SplitOptions"});
			if(myResult == true){
				var myStory = mySelection[0].parentStory;
				var myStoryFramesCount = myStory.textFrames.length;
				if(myStoryFramesCount > 1){
					for(f = 0; f < myStoryFramesCount; f++){
						if (mySelection[0] == myStory.textFrames[f]){
							var myTextFrame = f;
						}
					}
					switch(mySplitOptions.selectedButton){
						case 0:
							mySplitAll();
							break;
						case 1:
							mySplitBefore();
							break;
						case 2:
							mySplitAfter();
							break;
					}
				}
				else{
					alert("אתה עושה צחוק?!\nהסיפור שבחרת מכיל רק פריים אחד.");
				}
			}
		}
		else{
			alert("בחירה שגויה\nנבחרה מסגרת אובייקט שגויה. בבקשה בחר מסגרת טקסט.");
		}
	}
	else{
		alert(".לא נבחר כלום\n.בבקשה בחר סיפור לפיצול");
	}
}
else{
	alert(".לא נמצא מסמך פעיל\nבבקשה בתח מסמך InDesign, .ובחר סיפור לפיצול");
}

//----------------------------------------------------------------------------
function mySplitAll(){
	for(i = 0; i < myStoryFramesCount; i++){
		myStory.textFrames[i].duplicate();
	}
	for(i = 0; i < myStoryFramesCount; i++){
		myStory.textFrames[0].remove();
	}
}

function mySplitBefore(){
	if(mySelection[0].previousTextFrame == null){
		alert("Unable Break Thread.\nThe selected Text Frame is the FIRST text frame of the thread.");
	}
	else{
		var myBfBreakFrame = mySelection[0].previousTextFrame;
		var myAfBreakFrame = mySelection[0];
		var myBreakStory = myBfBreakFrame.parentStory;
		myStory.textFrames[myTextFrame].previousTextFrame = null;
		if(myBfBreakFrame.overflows == true){
			var myOversetText = myBreakStory.texts.itemByRange(myBreakStory.textFrames[-1].insertionPoints[-1],myBreakStory.insertionPoints[-1]);
			myOversetText.select();
			app.cut();
			app.select(myAfBreakFrame.insertionPoints[0]);
			app.paste();
		}
	}
}

function mySplitAfter(){
	if(mySelection[0].nextTextFrame == null){
		alert("Unable Break Thread.\nThe selected Text Frame is the LAST text frame of the thread.");
	}
	else{
		var myBfBreakFrame = mySelection[0];
		var myAfBreakFrame = mySelection[0].nextTextFrame;
		var myBreakStory = myBfBreakFrame.parentStory;
		myStory.textFrames[myTextFrame].nextTextFrame = null;
		if(myBfBreakFrame.overflows == true){
			var myOversetText = myBreakStory.texts.itemByRange(myBreakStory.textFrames[-1].insertionPoints[-1],myBreakStory.insertionPoints[-1]);
			myOversetText.select();
			app.cut();
			app.select(myAfBreakFrame.insertionPoints[0]);
			app.paste();
		
		}
	}
}